## luabind 0.9.1%2Bgit20150823%2Bdfsg

=== debian/changelog ===
luabind (0.9.1+git20150823+dfsg-3) unstable; urgency=medium

  * Add appropriate multi-arch hints in debian/control
  * Update to Standards-Version 4.5.0 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 22 Apr 2020 21:19:27 -0400

luabind (0.9.1+git20150823+dfsg-2) unstable; urgency=medium

  * README.Debian-source: Document creation of new upstream tarball

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 03 Sep 2019 15:29:21 -0400

luabind (0.9.1+git20150823+dfsg-1) unstable; urgency=medium

  * New upstream snapshot (76d4061) (Closes: #901296)
    + https://github.com/ValyriaTear/luabind
    + Drop obsolete patches
    + Update to use new CMake-based build system
    + Adjust SONAME, as new upstream has made ABI-incompatible changes
    + Install library and related files in multiarch directories
  * Update to debhelper compatibility level 10
  * Update to Standards-Version 4.4.0 (no changes)
  * Enable hardening flags when building

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 22 Aug 2019 16:13:01 -0400

luabind (0.9.1+dfsg-11) unstable; urgency=medium

  * Use -fPIC in example Makefiles (Closes: #819454)
  * Use secure URIs for Vcs-* fields in debian/control
  * Switch 'dh_clean -k' to 'dh_prep' in debian/rules
  * Add get-orig-source target in debian/rules
  * Add hardening flags to DEB_BUILD_MAINT_OPTIONS in debian/rules
  * Update to Standards-Version 3.9.8 (no changes)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 07 May 2016 13:14:39 -0400

luabind (0.9.1+dfsg-10) unstable; urgency=low

  * Refer to Lua 5.2 in pkg-config file (Closes: #799661)
  * Update to Standards-Version 3.9.6 (no changes)
  * Fix possible null pointer dereference in luabind::adopt; thanks to
    Andreas Grob for the patch (Closes: #758580)

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 14 Oct 2015 00:22:44 -0400

luabind (0.9.1+dfsg-9.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Update copyright file using copyright-format 1.0,
    document BSL-1.0 licensed files. (closes: #795235)

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 11 Sep 2015 20:25:21 +0200

luabind (0.9.1+dfsg-9.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add 00git_fix_build_with_boost1.57.patch: Fix FTBFS with current boost.
    (Closes: #795154)
  * Rename library packages for g++5 ABI transition. (Closes: #791196)

 -- Martin Pitt <mpitt@debian.org>  Tue, 11 Aug 2015 09:29:35 +0200

luabind (0.9.1+dfsg-9) unstable; urgency=low

  * Change Build-Depends from "libboost1.54-all-dev | libboost1.55-all-dev |
    libboost1.53-dev | libboost1.49-dev" to libboost-all-dev (Closes: #757542)
  * libluabind-dev: Change Depends from "libboost1.53-dev | libboost-dev
    (>= 1.46.1-3~)" to libboost-dev (Closes: #754425)
  * debian/rules: Add build-arch and build-indep targets to the .PHONY target

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 09 Aug 2014 18:58:32 -0400

luabind (0.9.1+dfsg-8) unstable; urgency=low

  * Drop Build-Depends on libboost1.53-dev (Closes: #731066)
  * Update to Standards-Version 3.9.5 (no changes)
  * Fix lintian errors (privacy-breach-w3c-valid-html & privacy-breach-logo)
    by removing remote image references in doc/index.html

 -- Roberto C. Sanchez <roberto@connexer.com>  Sun, 09 Mar 2014 21:26:27 -0400

luabind (0.9.1+dfsg-7) unstable; urgency=low

  * Tweak bjam invocation to account for instances where dpkg-buildflags
    returns an empty string; corrects FTBFS on ia64

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 13 Jul 2013 23:02:30 -0400

luabind (0.9.1+dfsg-6) unstable; urgency=low

  * Add Vcs-Git and Vcs-Browser fields in debian/control
  * Remove Arthur Loiret as maintainer (he has retired from the project)
    and move /me from uploaders to maintainer
  * Build with hardening options
  * Fix architecture independent and architecture dependent build targets
  * Update to Standards-Version 3.9.4 (no changes)
  * Support building with clang, cherry pick patch from upstream commit
    3044a90 (Closes: #660375) (LP: #1055374)
  * Add patch to fix bug in cast graph cache, thanks to Peter Colberg
    (Closes: #660380)
  * Adjust build dependencies to prefer building against Boost 1.53
    (Closes: #705182)
  * Add patch to support Lua 5.2, thanks to Peter Colberg (Closes: 660384)
  * Adjust build dependencies to build against Lua 5.2 instead of 5.1
  * Drop unnecessary dependency on libboost-python-dev  (LP: #568444)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 13 Jul 2013 13:46:43 -0400

luabind (0.9.1+dfsg-5) unstable; urgency=low

  * Fix FTBFS (Closes: #667833)
  * Bump standards version to 3.9.3 (no changes required)

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 23 Apr 2012 19:26:09 -0400

luabind (0.9.1+dfsg-4) unstable; urgency=low

  * Support new multi-arch library locations (Closes: #642728, #641502)

 -- Roberto C. Sanchez <roberto@connexer.com>  Sat, 01 Oct 2011 18:31:05 -0400

luabind (0.9.1+dfsg-3) unstable; urgency=low

  * Adjust Build-Depends for removal of boost-built (Closes: #629771)
  * Bump standards version to 3.9.2 (no changes required)

 -- Roberto C. Sanchez <roberto@connexer.com>  Tue, 14 Jun 2011 16:01:04 -0400

luabind (0.9.1+dfsg-2) unstable; urgency=low

  * New binary package libluabind0.9.1 replaces libluabind0.9.0 (Thanks
    to Roman Shtylman for catching the ommission in the previous upload)

 -- Roberto C. Sanchez <roberto@connexer.com>  Thu, 14 Oct 2010 18:58:44 -0400

luabind (0.9.1+dfsg-1) unstable; urgency=low

  * New Upstream Version
  * Refresh patches and remove 04_defer_longjmp.diff (now included upstream)
  * Fix watch file to properly mangle +dfsg suffix on upstream version
  * Update repack.sh script to deal with .tar.gz instead of .zip
  * Bump standards version to 3.9.1 (no changes required)
  * Specify source format as 3.0

 -- Roberto C. Sanchez <roberto@connexer.com>  Mon, 11 Oct 2010 14:21:48 -0400

luabind (0.9+dfsg-3) unstable; urgency=low



## luabind 0.9.1+git20150823+dfsg

=== CMakeLists.txt ===
# Build for LuaBind
# Ryan Pavlik <rpavlik@iastate.edu>
# http://academic.cleardefinition.com/
# Iowa State University HCI Graduate Program/VRAC

cmake_minimum_required(VERSION 2.8.3)
set(CMAKE_LEGACY_CYGWIN_WIN32 0) # Remove when CMake >= 2.8.4 is required
project(LuaBind)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

include(CheckCXXCompilerFlag)

set(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "9")
set(CPACK_PACKAGE_VERSION_PATCH "1")
set(CPACK_PACKAGE_VERSION
    "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

list(APPEND CMAKE_MODULE_PATH
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

if(NOT Boost_FOUND)
    set(Boost_USE_STATIC_LIBS     ON)
    set(Boost_USE_MULTITHREADED   ON)
    set(Boost_USE_STATIC_RUNTIME OFF)
    find_package(Boost REQUIRED)
endif()

if(NOT LUA_FOUND AND NOT LUA51_FOUND AND NOT LUA52_FOUND)
    set(LUABIND_LUA_VERSION "" CACHE STRING
        "51 or 52; empty to use 51 if 52 cannot be found and 52 otherwise.")

    if(LUABIND_LUA_VERSION)
        find_package("Lua${LUABIND_LUA_VERSION}" REQUIRED)
    else()
        find_package(Lua52)
        if(NOT LUA52_FOUND)
            find_package(Lua51)
            if(NOT LUA51_FOUND)
                message(FATAL_ERROR "Neither Lua 5.1 nor 5.2 could be found.")
            endif()
        endif()
    endif()
    set(LUA_INCLUDE_DIRS "${LUA_INCLUDE_DIR}")
endif()

if(NOT MSVC)
    check_cxx_compiler_flag(-std=c++11 LUABIND_HAS_CXX11)
    if (LUABIND_HAS_CXX11)
        set (LUABIND_CXX11_COMPILER_FLAGS "-std=c++11")
    else()
        message("Compiler does not support -std=c++11 flag, C++11 disabled.")
    endif()
elseif(MSVC_VERSION GREATER 1699) # 1700 = VS 11 (2012)
    set (LUABIND_HAS_CXX11 ON)
else()
    set (LUABIND_HAS_CXX11 OFF)
    message("MSVC < 11 (2012) detected, C++11 disabled.")
endif()

if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    # We are the top-level project
    option(LUABIND_INSTALL "Install the LuaBind library and headers" ON)
    option(LUABIND_APPEND_VERSION_SUFFIX "Append a version suffix to the library name (like luabind09)?" ON)
    option(LUABIND_NO_ERROR_CHECKING "Build so that all the Lua code is expected only to make legal calls?" OFF)
    option(LUABIND_NO_EXCEPTIONS "Disable all usage of try, catch, and throw?" OFF)
    option(LUABIND_CPLUSPLUS_LUA "Was Lua built as C++?" OFF)
    option(LUABIND_DYNAMIC_LINK "Build luabind as a shared library?" OFF)
    option(LUABIND_NOT_THREADSAFE "Permit the use of static variables, thus making Luabind usable only from one of your system threads." OFF)
    option(LUABIND_ENABLE_WARNINGS "Enable extra warnings during the build of the library and tests" ON)
    if (LUABIND_HAS_CXX11)
        option(LUABIND_USE_CXX11 "Build Luabind using C++11 features?" ON)
    else()
        set(LUABIND_USE_CXX11 OFF)
    endif()

    if(Boost_VERSION LESS 104700)
        set(LUABIND_USE_NOEXCEPT_DEF OFF)
        # 1900 = VS 14 (2015)
        if (LUABIND_CXX11_DEFAULT AND NOT MSVC OR MSVC_VERSION GREATER 1899)
            set(LUABIND_USE_NOEXCEPT_DEF ON)
        endif()
        option(LUABIND_USE_NOEXCEPT "If your compiler is C++11 compliant, but you're using old Boost, you need to set this." ${LUABIND_USE_NOEXCEPT_DEF})
        unset(LUABIND_USE_NOEXCEPT_DEF)
    endif()

    if(LUABIND_USE_CXX11 AND NOT LUABIND_HAS_CXX11)
        # The compiler supports no C++11
        set(LUABIND_USE_CXX11 OFF CACHE BOOL "Build Luabind using C++11 features?" FORCE)
    endif()

    if(LUABIND_USE_CXX11)
        option(LUABIND_NO_SCOPED_ENUM "Indicates that your compiler and standard library lacks scoped enums and std::underlying_type" OFF)
        set(LUABIND_NO_STD_SHARED_PTR OFF)
    else()
        # No CXX11, can't have scoped enum
        # TODO is this right?
        #set(LUABIND_NO_SCOPED_ENUM ON CACHE INTERNAL "" FORCE)
        option(LUABIND_NO_STD_SHARED_PTR "Indicates that your standard library lacks C++11 shared_ptr in std namespace" ON)
    endif()

endif()

if(LUABIND_NO_STD_SHARED_PTR)
    add_definitions(-DLUABIND_NO_STD_SHARED_PTR)
endif()

if(LUABIND_USE_CXX11)
    add_definitions(-DLUABIND_USE_CXX11)
endif()

# Configure the build info header
file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/luabind")
configure_file(build_information.hpp.cmake_in "${CMAKE_CURRENT_BINARY_DIR}/luabind/build_information.hpp")

# Set up the build
set(BUILD_SHARED_LIBS ${LUABIND_DYNAMIC_LINK})

if(LUABIND_USE_CXX11 AND LUABIND_CXX11_COMPILER_FLAGS)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${LUABIND_CXX11_COMPILER_FLAGS}")
endif()

# Test and enable warning flags if desired, as well as other compiler flag
macro(_luabind_add_flag _flag _var)
    check_cxx_compiler_flag(${_flag} ${_var})
    if(${_var})
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${_flag}")
    endif()
endmacro()

if(MSVC)
    # multi-process compile
    _luabind_add_flag(/MP SUPPORTS_MP_FLAG)
    if(LUABIND_ENABLE_WARNINGS)
        # Warning level 4
        _luabind_add_flag(/W4 SUPPORTS_W4_FLAG)

        # Disable incorrect warning C4709
        # ("comma operator within array index expression")
        _luabind_add_flag(/wd4709 SUPPORTS_WD4709_FLAG)

        IF (MSVC_VERSION GREATER 1899) # 1900 = MSVC 14 (2015)
            # Disable overly pendantic warning C4459 "declaration of 'var' hides
            # global declaration" which is issued a lot for 'result' which is
            # globally declared for policies.  See also
            # https://connect.microsoft.com/VisualStudio/feedback/details/1355600/.
            _luabind_add_flag(/wd4459 SUPPORTS_WD4459_FLAG)

            # Disable warning C4913 "user defined binary operator ',' exists but
            # no overload could convert all operands, default built-in binary
            # operator ',' used" which is triggered even when no comma is
            # involved at all, refering to the 'T const& x,
            # operator_void_return' overload in luabind::detail.
            _luabind_add_flag(/wd4913 SUPPORTS_WD4913_FLAG)
        endif()
    endif()
else()

    set(possible_flags)
    if(BUILD_SHARED_LIBS)
        list(APPEND possible_flags fvisibility=hidden)
    endif()
    if(LUABIND_ENABLE_WARNINGS)
        list(APPEND possible_flags
            Wall
            Wextra
            Wno-deprecated-declarations # auto_ptr is OK for now
            Wno-unused-macros
            Wlogical-op
            Wmissing-declarations
            Wsign-conversion
            pedantic
            Wcast-align
            Wcast-qual
            Wctor-dtor-privacy
            Winit-self
            Wdisabled-optimizations
            Wformat=2
            Wmissing-include-dirs
            Wold-style-cast
            Woverloaded-virtual
            Wredundant-decls
            Wshadow
            Wsign-promo
            Wstrict-null-sentinel
            Wstrict-overflow=5)


        if(LUABIND_USE_CXX11)
            list(APPEND possible_flags Wnoexcept)
        endif()

        if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
            list(APPEND possible_flags
                Weverything
                Wno-shadow
                Wno-undef
                Wno-global-constructors
                Wno-weak-vtables
                Wno-padded
                Wno-exit-time-destructors
                Wno-missing-noreturn)

            if(LUABIND_USE_CXX11)
               list(APPEND possible_flags
                    Wno-c++98-compat
                    Wno-c++98-compat-pedantic)
            else()
               list(APPEND possible_flags
                    Wno-c++11-long-long)
            endif()

        elseif(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" AND NOT LUABIND_USE_CXX11)
            list(APPEND possible_flags Wno-long-long)
        endif()

    endif()

    if(possible_flags)
        foreach(_flag ${possible_flags})
            string(REGEX REPLACE [-+=] _ sanitized_flag ${_flag})
            _luabind_add_flag(-${_flag} SUPPORTS_${sanitized_flag}_FLAG)
        endforeach()
    endif()
endif()

include_directories(BEFORE
    "${CMAKE_CURRENT_SOURCE_DIR}"
    "${CMAKE_CURRENT_BINARY_DIR}")
include_directories(AFTER
    ${Boost_INCLUDE_DIRS}
    ${LUA_INCLUDE_DIRS})

add_subdirectory(src)

# Set up testing and documentation, only if we are the top-level project.
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    include(CTest)
    if(BUILD_TESTING)
        add_subdirectory(test)
    endif()
    add_subdirectory(doc)
endif()

if(LUABIND_INSTALL)
    if(WIN32 AND NOT CYGWIN)
        set(INSTALL_CMAKE_DIR CMake)
        set(INSTALL_CMAKE_DIR_LUA CMake)
    else()
        set(INSTALL_CMAKE_DIR lib/CMake/Luabind)
        set(INSTALL_CMAKE_DIR_LUA lib/CMake/Lua52)
    endif()
    install(FILES "cmake/Modules/FindLuabind.cmake" DESTINATION ${INSTALL_CMAKE_DIR})
    install(FILES "cmake/Modules/FindLua52.cmake" DESTINATION ${INSTALL_CMAKE_DIR_LUA})
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/luabind/build_information.hpp" DESTINATION include/luabind)
endif()

=== doc/CMakeLists.txt ===
# Embedded build for LuaBind
# 2009-2011 Ryan Pavlik <rpavlik@iastate.edu>
# http://academic.cleardefinition.com/
# Iowa State University HCI Graduate Program/VRAC

set(SOURCES
    conf.py
    acknowledgments.rst
    basic-usage.rst
    build-options.rst
    building.rst
    classes.rst
    errors.rst
    exceptions.rst
    faq.rst
    functions.rst
    impl-notes.rst
    index.rst
    intro.rst
    issues.rst
    lua-classes.rst
    object.rst
    policies.rst
    scopes.rst
    split-registration.rst
    userdefined-converters.rst
    policies/adopt.rst
    policies/copy.rst
    policies/dependency.rst
    policies/discard_result.rst
    policies/out_value.rst
    policies/pure_out_value.rst
    policies/raw.rst
    policies/return_reference_to.rst
    policies/return_stl_iterator.rst
    policies/yield.rst)

    
if (WIN32)
    list (APPEND SOURCES make.bat)
    set(SPHINX_CMD "${CMAKE_CURRENT_BINARY_DIR}/make.bat" html)
else()
    list (APPEND SOURCES Makefile)
    set(SPHINX_CMD make html)
endif()

set(SOURCES_COPIED)
foreach(SOURCE ${SOURCES})
    set(CURRENT_SOURCE_O "${CMAKE_CURRENT_BINARY_DIR}/${SOURCE}")
    add_custom_command(OUTPUT ${CURRENT_SOURCE_O}
        COMMAND "${CMAKE_COMMAND}" -E copy_if_different "${CMAKE_CURRENT_SOURCE_DIR}/${SOURCE}" ${CURRENT_SOURCE_O}
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${SOURCE}"
        COMMENT "Copying ${SOURCE}")
    list(APPEND SOURCES_COPIED ${CURRENT_SOURCE_O})
endforeach()

include(GetGitRevisionDescription.cmake)
git_describe(GIT_DESCRIPTION)
if(GIT_DESCRIPTION)
    string(REGEX REPLACE "^v" "" DOCS_VERSION "${GIT_DESCRIPTION}")
else()
    set(DOCS_VERSION "${CPACK_PACKAGE_VERSION}")
endif()

configure_file(git_version.in "${CMAKE_CURRENT_BINARY_DIR}/git_version")
list(APPEND SOURCES "${CMAKE_CURRENT_BINARY_DIR}/git_version.py")

add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/_build/"
    COMMAND ${SPHINX_CMD}
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    DEPENDS ${SOURCES_COPIED}
    VERBATIM
    COMMENT "Generating HTML documentation with sphinx makefile/script.")
add_custom_target(doc DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/_build/")

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest gettext

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Luabind.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Luabind.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Luabind"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Luabind"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== src/CMakeLists.txt ===
# Build for LuaBind
# Ryan Pavlik <rpavlik@iastate.edu>
# http://academic.cleardefinition.com/
# Iowa State University HCI Graduate Program/VRAC

# ls *.cpp | sort | sed "s/^/    /"
set(LUABIND_SRCS
    class.cpp
    class_info.cpp
    class_registry.cpp
    class_rep.cpp
    create_class.cpp
    error.cpp
    exception_handler.cpp
    function.cpp
    function_introspection.cpp
    inheritance.cpp
    link_compatibility.cpp
    lua51compat.cpp
    object_rep.cpp
    open.cpp
    operator.cpp
    pcall.cpp
    scope.cpp
    set_package_preload.cpp
    shared_ptr_converter.cpp
    stack_content_by_name.cpp
    weak_ref.cpp
    wrapper_base.cpp)

# ls ../luabind/*.hpp | sort | sed "s/^/    /"
set(LUABIND_API
    ../luabind/adopt_policy.hpp
    ../luabind/back_reference_fwd.hpp
    ../luabind/back_reference.hpp
    ../luabind/class.hpp
    ../luabind/class_info.hpp
    ../luabind/config.hpp
    ../luabind/container_policy.hpp
    ../luabind/copy_policy.hpp
    ../luabind/dependency_policy.hpp
    ../luabind/discard_result_policy.hpp
    ../luabind/error_callback_fun.hpp
    ../luabind/error.hpp
    ../luabind/exception_handler.hpp
    ../luabind/from_stack.hpp
    ../luabind/function_converter.hpp
    ../luabind/function.hpp
    ../luabind/function_introspection.hpp
    ../luabind/get_main_thread.hpp
    ../luabind/get_pointer.hpp
    ../luabind/handle.hpp
    ../luabind/intrusive_ptr_converter.hpp
    ../luabind/iterator_policy.hpp
    ../luabind/luabind.hpp
    ../luabind/lua_include.hpp
    ../luabind/lua_state_fwd.hpp
    ../luabind/make_function.hpp
    ../luabind/nil.hpp
    ../luabind/no_dependency.hpp
    ../luabind/object_fwd.hpp
    ../luabind/object.hpp
    ../luabind/open.hpp
    ../luabind/operator.hpp
    ../luabind/out_value_policy.hpp
    ../luabind/prefix.hpp
    ../luabind/raw_policy.hpp
    ../luabind/return_reference_to_policy.hpp
    ../luabind/scope.hpp
    ../luabind/set_package_preload.hpp
    ../luabind/shared_ptr_converter.hpp
    ../luabind/stack.hpp
    ../luabind/std_shared_ptr_converter.hpp
    ../luabind/tag_function.hpp
    ../luabind/typeid.hpp
    ../luabind/value_wrapper.hpp
    ../luabind/version.hpp
    ../luabind/weak_ref.hpp
    ../luabind/wrapper_base.hpp
    ../luabind/yield_policy.hpp)
source_group(API FILES ${LUABIND_API})

# ls ../luabind/detail/*.hpp | sort | sed "s/^/    /"
set(LUABIND_DETAIL_API
    ../luabind/detail/call_function.hpp
    ../luabind/detail/call.hpp
    ../luabind/detail/call_member.hpp
    ../luabind/detail/call_operator_iterate.hpp
    ../luabind/detail/class_registry.hpp
    ../luabind/detail/class_rep.hpp
    ../luabind/detail/constructor.hpp
    ../luabind/detail/convert_to_lua.hpp
    ../luabind/detail/debug.hpp
    ../luabind/detail/decorate_type.hpp
    ../luabind/detail/deduce_signature.hpp
    ../luabind/detail/enum_maker.hpp
    ../luabind/detail/format_signature.hpp
    ../luabind/detail/garbage_collector.hpp
    ../luabind/detail/has_get_pointer.hpp
    ../luabind/detail/inheritance.hpp
    ../luabind/detail/instance_holder.hpp
    ../luabind/detail/link_compatibility.hpp
    ../luabind/detail/make_instance.hpp
    ../luabind/detail/most_derived.hpp
    ../luabind/detail/object_call.hpp
    ../luabind/detail/object.hpp
    ../luabind/detail/object_rep.hpp
    ../luabind/detail/operator_id.hpp
    ../luabind/detail/other.hpp
    ../luabind/detail/pcall.hpp
    ../luabind/detail/pointee_sizeof.hpp
    ../luabind/detail/policy.hpp
    ../luabind/detail/primitives.hpp
    ../luabind/detail/property.hpp
    ../luabind/detail/signature_match.hpp
    ../luabind/detail/stack_utils.hpp
    ../luabind/detail/typetraits.hpp
    ../luabind/detail/yes_no.hpp)
source_group(Internal FILES ${LUABIND_DETAIL_API})

set(LUABIND_EXTRA_LIBS)
if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4251")
elseif(CMAKE_COMPILER_IS_GNUCXX)
    # TODO we often need libm, not just with gcc.
    list(APPEND LUABIND_EXTRA_LIBS m)
endif()

set(CMAKE_DEBUG_POSTFIX "-d")
add_library(luabind ${LUABIND_SRCS} ${LUABIND_API} ${LUABIND_DETAIL_API})
target_link_libraries(luabind ${LUA_LIBRARIES} ${LUABIND_EXTRA_LIBS} ${CMAKE_DL_LIBS})
set_property(TARGET
    luabind PROPERTY
    COMPILE_FLAGS
    ${CMAKE_SHARED_LIBRARY_C_FLAGS})

set_property(TARGET
    luabind
    PROPERTY
    PROJECT_LABEL
    "LuaBind Library")

if (LUABIND_APPEND_VERSION_SUFFIX)
    set_property(TARGET
        luabind
        PROPERTY
        OUTPUT_NAME
        "luabind09")
else()
    # This is neccesary when the LUABIND_APPEND_VERSION_SUFFIX variable is
    # changed from ON to OFF.
    set_property(TARGET
        luabind
        PROPERTY
        OUTPUT_NAME
        "luabind")
endif()

set(ALLHEADERS ${LUABIND_API} ${LUABIND_DETAIL_API} PARENT_SCOPE)
set(APIHEADERS ${LUABIND_API} PARENT_SCOPE)

if(LUABIND_INSTALL)
    if(NOT INCLUDE_DIR)
        set(INCLUDE_DIR include)
    endif()
    if(NOT LIB_DIR)
        set(LIB_DIR lib)
    endif()
    if(NOT ARCH_DIR)
        set(ARCH_DIR lib)
    endif()
    if(NOT BIN_DIR)
        set(BIN_DIR bin)
    endif()
    install(FILES ${LUABIND_API}
        DESTINATION ${INCLUDE_DIR}/luabind
        COMPONENT sdk)
    install(FILES ${LUABIND_DETAIL_API}
        DESTINATION ${INCLUDE_DIR}/luabind/detail
        COMPONENT sdk)
    install(TARGETS luabind
        EXPORT luabind
        RUNTIME DESTINATION ${BIN_DIR} COMPONENT runtime
        LIBRARY DESTINATION ${LIB_DIR} COMPONENT runtime
        ARCHIVE DESTINATION ${ARCH_DIR} COMPONENT sdk)
endif()

=== test/CMakeLists.txt ===
# Build for LuaBind
# Ryan Pavlik <rpavlik@iastate.edu>
# http://academic.cleardefinition.com/
# Iowa State University HCI Graduate Program/VRAC

# ls test_*.cpp | sort | sed -e 's/test_//' -e 's/.cpp//' -e 's/^/    /' | grep -v "has_get_pointer"
# This command removes has_get_pointer because it is a compile-only test
set(TESTS
    abstract_base
    adopt
    adopt_wrapper
    attributes
    automatic_smart_ptr
    back_reference
    builtin_converters
    class_info
    collapse_converter
    const
    construction
    create_in_thread
    def_from_base
    destruction
    dynamic_type
    exception_handlers
    exceptions
    extend_class_in_lua
    free_functions
    function_converter
    function_introspection
    function_object
    function_overload_overflow
    held_type
    implicit_cast
    implicit_raw
    intrusive_ptr
    iterator
    lua_classes
    null_pointer
    object
    operators
    # out_value // Currently fails to compile
    package_preload
    policies
    private_destructors
    properties
    scope
    separation
    set_instance_value
    shadow
    shared_ptr
    simple_class
    smart_ptr_attributes
    super_leak
    table
    tag_function
    typetraits
    unchecked
    unsigned_int
    user_defined_converter
    value_wrapper
    vector_of_object
    vector_of_number
    virtual_inheritance
    yield)

add_library(test_main STATIC
    main.cpp
    test.hpp
    # These tests consist only of compile time asserts and define no test_main
    # function:
    test_has_get_pointer.cpp)

if (BUILD_SHARED_LIBS AND MSVC)
    add_custom_command(TARGET test_main POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy
            $<TARGET_FILE:luabind> $<TARGET_FILE_DIR:testmain>
        COMMENT "Copying DLL...")
endif()

foreach(test ${TESTS})
    add_executable(test_${test} test_${test}.cpp)
    target_link_libraries(test_${test} test_main luabind)
    add_test(NAME ${test} COMMAND test_${test})
    set_property(TARGET test_${test} PROPERTY FOLDER "Tests")
endforeach()

if (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang" AND LUABIND_ENABLE_WARNINGS)
    set (priv_dtor_flags "-Wno-ctor-dtor-privacy")
    if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        set(priv_dtor_flags "${priv_dtor_flags} -Wno-unused-member-function")
    endif()
    set_property(TARGET test_private_destructors
                 PROPERTY COMPILE_FLAGS "${priv_dtor_flags}")
    set_property(TARGET test_builtin_converters
                 PROPERTY COMPILE_FLAGS "-Wno-float-equal")
endif()

add_executable(benchmark "benchmark.cpp")
target_link_libraries(benchmark ${LUA_LIBRARIES} luabind)

option(LUABIND_BUILD_HEADER_TESTS "Try to compile every header in the luabind directory, excluding detail headers, in its own translation unit, to check for missing includes." OFF)

if(BUILD_TESTING AND LUABIND_BUILD_HEADER_TESTS)
    get_filename_component(BASE "${CMAKE_CURRENT_SOURCE_DIR}/../luabind" ABSOLUTE)
    foreach(HEADER ${APIHEADERS})
        get_filename_component(FULLHEADER "${HEADER}" ABSOLUTE)
        file(RELATIVE_PATH SHORTNAME "${BASE}" "${FULLHEADER}")
        string(REPLACE "/" "_" SHORTNAME "${SHORTNAME}")
        string(REPLACE ".hpp" "" SHORTNAME "${SHORTNAME}")
        set (targetname test_headercompile_${SHORTNAME})
        set (cppname "${CMAKE_CURRENT_BINARY_DIR}/${targetname}.cpp")
        configure_file(test_headercompile.cpp.in "${cppname}" @ONLY)
        add_executable(${targetname} ${cppname})
        if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND LUABIND_ENABLE_WARNINGS)
            # Clang complains about '#define LUABIND_TEST_HEADERCOMPILE'.
            set_property(TARGET ${targetname}
                    PROPERTY COMPILE_FLAGS "-Wno-unused-macros")
        endif()
        set_property(TARGET ${targetname} PROPERTY FOLDER "Tests/Headers")
        target_link_libraries(${targetname} luabind)
    endforeach()
endif()

## luabind 0.9.1+dfsg

=== debian/control ===
Source: luabind
Priority: optional
Maintainer: Roberto C. Sanchez <roberto@connexer.com>
Build-Depends: debhelper (>= 5), quilt (>= 0.40), liblua5.2-dev, libboost1.54-all-dev | libboost1.55-all-dev | libboost1.53-dev | libboost1.49-dev
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.rasterbar.com/products/luabind.html
Vcs-Git: git://anonscm.debian.org/users/roberto/luabind.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=users/roberto/luabind.git;a=summary

Package: libluabind0.9.1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: luabind c++ binding for lua: runtime library
 Luabind is a library that helps you create bindings between C++ and Lua.
 It has the ability to expose functions and classes, written in C++, to
 Lua. It will also supply the functionality to define classes in lua and
 let them derive from other lua classes or C++ classes. Lua classes can
 override virtual functions from their C++ baseclasses. It is written
 towards Lua 5.0, and does not work with other Lua versions.
 .
 This package contains the luabind runtime libraries, for applications that
 have been built with luabind.

Package: libluabind-dbg
Section: debug
Priority: extra
Architecture: any
Depends: libluabind0.9.1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Suggests: libluabind-dev
Description: luabind c++ binding for lua: unstripped binaries
 Luabind is a library that helps you create bindings between C++ and Lua.
 It has the ability to expose functions and classes, written in C++, to
 Lua. It will also supply the functionality to define classes in lua and
 let them derive from other lua classes or C++ classes. Lua classes can
 override virtual functions from their C++ baseclasses. It is written
 towards Lua 5.0, and does not work with Lua other Lua versions.
 .
 This package contains the luabind unstripped binaries, for debugging
 applications developed with luabind.

Package: libluabind-dev
Section: libdevel
Architecture: any
Depends: libluabind0.9.1  (= ${binary:Version}), ${shlibs:Depends}, liblua5.2-dev, libboost1.53-dev | libboost-dev (>= 1.46.1-3~), ${misc:Depends}
Suggests: libluabind-doc, libluabind-examples
Description: luabind c++ binding for lua: static library and headers
 Luabind is a library that helps you create bindings between C++ and Lua.
 It has the ability to expose functions and classes, written in C++, to
 Lua. It will also supply the functionality to define classes in lua and
 let them derive from other lua classes or C++ classes. Lua classes can
 override virtual functions from their C++ baseclasses. It is written
 towards Lua 5.0, and does not work with other Lua versions.
 .
 This package contains all files necessary to develop applications which
 use luabind.

Package: libluabind-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Recommends: libluabind-dev
Description: luabind c++ binding for lua: documentation files
 Luabind is a library that helps you create bindings between C++ and Lua.
 It has the ability to expose functions and classes, written in C++, to
 Lua. It will also supply the functionality to define classes in lua and
 let them derive from other lua classes or C++ classes. Lua classes can
 override virtual functions from their C++ baseclasses. It is written
 towards Lua 5.0, and does not work with other Lua versions.
 .
 This package contains the luabind documentation.

Package: libluabind-examples
Section: libdevel
Architecture: all
Depends: ${misc:Depends}
Recommends: libluabind-dev
Description: luabind c++ binding for lua: example files
 Luabind is a library that helps you create bindings between C++ and Lua.
 It has the ability to expose functions and classes, written in C++, to
 Lua. It will also supply the functionality to define classes in lua and
 let them derive from other lua classes or C++ classes. Lua classes can
 override virtual functions from their C++ baseclasses. It is written
 towards Lua 5.0, and does not work with other Lua versions.
 .
 This package contains some luabind examples, including the basic "helloworld"
 and some more advanced examples.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/quilt/quilt.make

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_HOST_MULTIARCH

tests := $(filter-out main.cpp,$(subst test/,,$(wildcard test/*.cpp)))

build: build-arch build-indep
build-arch: build-stamp
build-indep: build-stamp
build-stamp: patch
	dh_testdir
	# The -d2 option makes bjam output the actual commands it is using
	bjam -d2 release debug cflags=" $(shell dpkg-buildflags --get CFLAGS)" cxxflags=" $(shell dpkg-buildflags --get CXXFLAGS)" linkflags=" $(shell dpkg-buildflags --get LDFLAGS)"
	# Create symlinks that bjam doesn't create
	find . -name libluabindd.so.0.9.1 -execdir ln -sf libluabindd.so.0.9.1 libluabind.so.0.9.1 \;
	find . -name libluabindd.so.0.9.1 -execdir objcopy --only-keep-debug libluabindd.so.0.9.1 libluabindd.so.0.9.1.dbg \;
	find . -name libluabindd.so.0.9.1 -execdir rm libluabindd.so.0.9.1 \;
	find . -name libluabindd.so.0.9.1.dbg -execdir mv libluabindd.so.0.9.1.dbg libluabindd.so.0.9.1 \;
	find . -name libluabind.so.0.9.1 -execdir ln -sf libluabind.so.0.9.1 libluabind.so \;
	# We also need a .a library for the -dev package
	bjam -d2 release debug link=static cflags=" $(shell dpkg-buildflags --get CFLAGS)" cxxflags=" $(shell dpkg-buildflags --get CXXFLAGS)" linkflags=" $(shell dpkg-buildflags --get LDFLAGS)"
	#FIXME: dh_fixperms does not recognize .hpp or .lua files
	find . -type f -name "*.cpp" -or -name "*.hpp" -or -name "*.lua" | xargs chmod 644
	find . -type f -name "Jamfile" -or -name "*.jam" -or -name "makefile" | xargs rm -f

	# If the build arch and the target arch are the same, also run tests
ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	@cd test && CFLAGS="$(shell dpkg-buildflags --get CFLAGS)" CXXFLAGS="$(shell dpkg-buildflags --get CXXFLAGS)" LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS)" g++ -o main.o -c main.cpp -I.. -I/usr/include/lua5.2 -I/usr/include/boost && \
	for i in $(tests) ; \
		do echo -n "Building $$i... " && \
		if CFLAGS="$(shell dpkg-buildflags --get CFLAGS)" CXXFLAGS="$(shell dpkg-buildflags --get CXXFLAGS)" LDFLAGS="$(shell dpkg-buildflags --get LDFLAGS)" g++ -o test_temp $$i main.o -I.. -I/usr/include/lua5.2 -I/usr/include/boost \
		`find .. -name libluabind.a` -llua5.2 2>test_log >/dev/null ; then \
			if test -s test_log ; then \
				echo "OK, warnings:" && \
				cat test_log | sed -r 's/(.*)/  \1/g' ; \
			else \
				echo "OK." ; \
			fi ; \
			echo -n "Running  $$i... " && \
			if ./test_temp ; then \
				echo "OK." ; \
			else \
				echo "FAILED TO RUN." ; \
			fi ; \
		else \
			echo "FAILED TO BUILD:" && \
			cat test_log | sed -r 's/(.*)/  \1/g' ; \
		fi ; \
		echo ; rm -f test_temp test_log ; \
	done
endif

	touch $@

clean: unpatch
	dh_testdir
	dh_testroot
	rm -f build-stamp
	rm -f test/main.o
	rm -rf bin
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

binary-indep: install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_installchangelogs -i -plibluabind-doc doc/changes.txt
	dh_installexamples -i
	dh_install -i
	dh_link -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

binary-arch: install
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installexamples -a
	dh_installdocs -a debian/copyright
	dh_install -a
	dh_link -a
	dh_strip -a --dbg-package=libluabind-dbg
	dh_compress -a -X.lua
	dh_fixperms -a
	dh_makeshlibs -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3

opts="dversionmangle=s/\+dfsg[.\d]*//" \
http://sf.net/luabind/luabind-([.0-9]+)\.(?:tar(?:\.gz|\.bz2)?|tgz|zip) debian debian/repack.sh

## luabind 0.9.1+git20150823+dfsg

=== debian/changelog ===
luabind (0.9.1+git20150823+dfsg-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113253)

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Oct 2025 12:40:02 +0200

luabind (0.9.1+git20150823+dfsg-3.1) unstable; urgency=medium

  * Non-maintainer upload
  * Downgrade to lua 5.1 (Closes: #1050540)
  * d/watch: Scan GitHub tags

 -- Bastian Germann <bage@debian.org>  Fri, 25 Aug 2023 22:10:22 +0000

=== debian/control ===
Source: luabind
Priority: optional
Maintainer: Roberto C. Sanchez <roberto@connexer.com>
Build-Depends: debhelper (>= 10),
 cmake,
 liblua5.1-0-dev,
 libboost-all-dev,
 python3-sphinx
Standards-Version: 4.5.0
Section: libs
Homepage: https://github.com/ValyriaTear/luabind

Package: libluabind0.9.1d1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: luabind c++ binding for Lua: runtime library
 Luabind is a library that helps you create bindings between C++ and Lua.
 It has the ability to expose functions and classes, written in C++, to
 Lua. It will also supply the functionality to define classes in Lua and
 let them derive from other Lua classes or C++ classes. Lua classes can
 override virtual functions from their C++ baseclasses. It is written
 towards Lua 5.0, and does not work with other Lua versions.
 .
 This package contains the luabind runtime libraries, for applications that
 have been built with luabind.

Package: libluabind-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libluabind0.9.1d1  (= ${binary:Version}), ${shlibs:Depends}, liblua5.1-0-dev, libboost-dev, ${misc:Depends}
Suggests: libluabind-doc, libluabind-examples
Description: luabind c++ binding for Lua: static library and headers
 Luabind is a library that helps you create bindings between C++ and Lua.
 It has the ability to expose functions and classes, written in C++, to
 Lua. It will also supply the functionality to define classes in Lua and
 let them derive from other Lua classes or C++ classes. Lua classes can
 override virtual functions from their C++ baseclasses. It is written
 towards Lua 5.0, and does not work with other Lua versions.
 .
 This package contains all files necessary to develop applications which
 use luabind.

Package: libluabind-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: libluabind-dev
Description: luabind c++ binding for Lua: documentation files
 Luabind is a library that helps you create bindings between C++ and Lua.
 It has the ability to expose functions and classes, written in C++, to
 Lua. It will also supply the functionality to define classes in Lua and
 let them derive from other Lua classes or C++ classes. Lua classes can
 override virtual functions from their C++ baseclasses. It is written
 towards Lua 5.0, and does not work with other Lua versions.
 .
 This package contains the luabind documentation.

Package: libluabind-examples
Section: libdevel
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: libluabind-dev
Description: luabind c++ binding for Lua: example files
 Luabind is a library that helps you create bindings between C++ and Lua.
 It has the ability to expose functions and classes, written in C++, to
 Lua. It will also supply the functionality to define classes in Lua and
 let them derive from other Lua classes or C++ classes. Lua classes can
 override virtual functions from their C++ baseclasses. It is written
 towards Lua 5.0, and does not work with other Lua versions.
 .
 This package contains some luabind examples, including the basic "helloworld"
 and some more advanced examples.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -Bbuild-static -- -DBUILD_TESTING=ON -DLUABIND_BUILD_HEADER_TESTS=ON -DBUILD_SHARED_LIBS=OFF -DLUABIND_DYNAMIC_LINK=OFF -DLUABIND_LIBRARY_VERSION=0.9.1d1 -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)"
	dh_auto_configure -Bbuild-shared -- -DBUILD_TESTING=ON -DLUABIND_BUILD_HEADER_TESTS=ON -DBUILD_SHARED_LIBS=ON -DLUABIND_DYNAMIC_LINK=ON -DLUABIND_LIBRARY_VERSION=0.9.1d1 -DCMAKE_LIBRARY_ARCHITECTURE="$(DEB_TARGET_MULTIARCH)"

override_dh_auto_build:
	dh_auto_build -Bbuild-static
	dh_auto_build -Bbuild-shared
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
	echo "Found 'nodoc' in 'DEB_BUILD_OPTIONS'; not building documentation"
else
	# Upstream's documentation build is broken, so perform the steps manually
	cd build-shared/doc && \
	       cp -rf ../../doc/policies ../../doc/*.rst ../../doc/*.py . && \
	       $(MAKE) -f ../../doc/Makefile man && \
	       $(MAKE) -f ../../doc/Makefile html
endif

override_dh_auto_test:
	dh_auto_test -Bbuild-static
	dh_auto_test -Bbuild-shared

override_dh_auto_install:
	dh_auto_install -Bbuild-static
	dh_auto_install -Bbuild-shared
	install -d $(CURDIR)/debian/tmp/usr/lib/$(DEB_TARGET_MULTIARCH)/pkgconfig
	install -p -m0644 debian/luabind.pc $(CURDIR)/debian/tmp/usr/lib/$(DEB_TARGET_MULTIARCH)/pkgconfig
	install -d $(CURDIR)/debian/tmp/examples
	cp -rf $(CURDIR)/examples/* $(CURDIR)/debian/tmp/examples/
	find $(CURDIR)/debian/tmp/examples -type f -name "*.cpp" -or -name "*.hpp" -or -name "*.lua" | xargs chmod 644
	find $(CURDIR)/debian/tmp/examples -type f -name "Jamfile" -or -name "*.jam" -or -name "makefile" | xargs rm -f

=== debian/watch ===
version=4
https://github.com/ValyriaTear/luabind/tags .*/tags/([\d\.]+)\.tar\.gz
